<script lang="ts">
  import { clamp } from '@common/helpers/NumberHelper.js';
  import { hasTouchScreen, isRealMobile } from '@web-common/helpers/DeviceHelper.js';
  import { windowSizeState } from '@web-common/hooks/browser-states/window-size-state.js';
  import { onMount } from 'svelte';
  import NavButton from './NavButton.svelte';

  export let control = true;
  export let fullWidth = false;

  let slides: HTMLDivElement;
  let showControl = false;
  let enableLeft = false;
  let enableRight = true;

  onMount(() => {
    const checkControl = () => {
      if (isRealMobile()) {
        return;
      }

      showControl = control && !hasTouchScreen();
    };

    checkControl();

    const { subscribe, cleanUp } = windowSizeState('(width >= 768px)');
    subscribe(checkControl);
    return () => cleanUp();
  });

  const onClick = (type: 'left' | 'right') => {
    let margin = 20;
    let maxWidth = clamp(window.innerWidth, 0, 1000) - margin;

    let slidePos = 0;
    if (type === 'right') {
      slides.scrollLeft = slidePos = slides.scrollLeft + maxWidth;
    } else {
      slides.scrollLeft = slidePos = slides.scrollLeft - maxWidth;
    }

    enableLeft = slidePos > 0;
    enableRight = slidePos + slides.offsetWidth < slides.scrollWidth;
  };
</script>

<div class="carousel">
  <div
    bind:this={slides}
    class="slides"
    class:full-width={fullWidth}>
    <slot />
  </div>
  {#if showControl}
    <div class="controls">
      <span class="carousel-control left">
        <NavButton
          on:click={onClick.bind(null, 'left')}
          enabled={enableLeft} /></span>
      <span class="carousel-control right">
        <NavButton
          on:click={onClick.bind(null, 'right')}
          enabled={enableRight} /></span>
    </div>
  {/if}
</div>

<style type="postcss">
  .carousel {
    position: relative;
  }

  .slides {
    display: flex;
    overflow-x: scroll;
    scroll-behavior: smooth;

    /*  use this pseudo class to hide the scrollbar on chrome */
    &::-webkit-scrollbar {
      display: none;
    }
  }

  .carousel :global(.carousel-item) {
    width: 150px;
  }

  .controls {
    position: absolute;
    top: 50%;
    display: flex;
    width: 100%;
    height: 0;
    align-items: center;
    justify-content: space-between;

    & .carousel-control {
      position: relative;
      display: inline-block;
      width: fit-content;
      justify-content: space-between;

      &.left {
        display: inline-flex;
        transform: scaleX(-1);
      }

      &.right {
        display: inline-flex;
      }
    }
  }

  .full-width {
    padding-inline: var(--space-vw-1);
  }

  @media (width >= 768px) and (width <= 1000px) {
    .carousel :global(.carousel-item) {
      width: calc(25vw - (var(--content-margin) * 0.25) + (var(--content-margin) * 0.25));
    }
  }

  @media (width >= 1000px) {
    .carousel :global(.carousel-item) {
      width: calc((var(--content-max-width-1) * 0.247) + (var(--content-margin) * 0.01));
    }
  }
</style>
